import { useEffect, useState } from "react";
export default function useOnScreen(ref, rootMargin) {
    if (rootMargin === void 0) { rootMargin = "0px"; }
    var _a = useState(false), isVisible = _a[0], setIsVisible = _a[1];
    useEffect(function () {
        if (ref.current == null)
            return;
        var observer = new IntersectionObserver(function (_a) {
            var entry = _a[0];
            return setIsVisible(entry.isIntersecting);
        }, { rootMargin: rootMargin });
        observer.observe(ref.current);
        return function () {
            if (ref.current == null)
                return;
            observer.unobserve(ref.current);
        };
    }, [ref.current, rootMargin]);
    return isVisible;
}
