import { useCallback, useState, useEffect } from "react";
export default function useStorage(key, defaultValue, storage) {
    var storageObject = window[storage];
    var _a = useState(function () {
        var jsonValue = storageObject.getItem(key);
        if (jsonValue !== null)
            return JSON.parse(jsonValue);
        if (typeof defaultValue === "function") {
            return defaultValue();
        }
        else {
            return defaultValue;
        }
    }), value = _a[0], setValue = _a[1];
    useEffect(function () {
        if (value === undefined) {
            storageObject.removeItem(key);
        }
        else {
            storageObject.setItem(key, JSON.stringify(value));
        }
    }, [key, value, storageObject]);
    var remove = useCallback(function () {
        setValue(undefined);
    }, []);
    return [value, setValue, remove];
}
export function useLocalStorage(key, defaultValue) {
    return useStorage(key, defaultValue, "localStorage");
}
export function useSessionStorage(key, defaultValue) {
    return useStorage(key, defaultValue, "sessionStorage");
}
